// *************************************************************************
//    BacktrackInfoArray.h
// *************************************************************************

#ifndef _BacktrackInfoArray_H_
#define _BacktrackInfoArray_H_

#include "RuleInfoArray.h"
#include "Debug.h"

// *************************************************************************
// Backtrack information corresponding to the RuleInfoArray of the
// QFModuleData structure

class Cor_BacktrackInfoArray {
  public:
    int numRules;
    int **firstFailureBacktrackArrays;   // size of array is numRules
    int **nextFailureBacktrackArrays;    // size of array is numRules
    int  *successBacktrackPoints;        // size of array is numRules

    Cor_BacktrackInfoArray(Cor_RuleInfoArray *);
   ~Cor_BacktrackInfoArray();

     // Alter backtrack points to implement naive backtracking
    void set_naive_backtracking(Cor_RuleInfoArray *rArray);
};

// *************************************************************************

#endif _BacktrackInfoArray_H_
