
inline RdbJoinCondition::RdbJoinCondition( int r1, int c1, int r2, int c2 )
{
    rel1 = r1;
    col1 = c1;
    rel2 = r2;
    col2 = c2;
}

inline int RdbJoinCondition::Rel1() const
{
    return rel1;
}

inline int RdbJoinCondition::Col1() const
{
    return col1;
}

inline int RdbJoinCondition::Rel2() const
{
    return rel2;
}

inline int RdbJoinCondition::Col2() const
{
    return col2;
}

/***************************************************************************/

inline RdbJoin::RdbJoin(const RdbRelList& newRelList,
			const RdbJoinCondList& newJoinCond)
: relList(newRelList),
  joinCond(newJoinCond)
{
    assert(relList.Size()>0);
}


inline RdbJoin::RdbJoin(const RdbJoin& other)
: relList(other.relList),
  joinCond(other.joinCond)
{
}


inline RdbSystem& RdbJoin::System() const
{
    return relList[0]->System();
}


inline RdbDatabase& RdbJoin::Database() const
{
    return relList[0]->Database();
}


inline String RdbJoin::SystemName() const
{
    return relList[0]->SystemName();
}


inline String RdbJoin::DatabaseName() const
{
    return relList[0]->DatabaseName();
}


inline int RdbJoin::RelCount() const
{
    return relList.Size(); 
}


inline int RdbJoin::JoinCount() const
{
    return joinCond.Size();
}


inline RdbRelation& RdbJoin::Rel(int i) const
{
    return *relList[i];
}


inline String RdbJoin::RelName(int i) const
{
    return relList[i]->RelName();
}


inline String RdbJoin::ColName(int i) const
{
    return QualifiedColName(i);
}


inline RdbJoin& RdbJoin::operator =(const RdbJoin& other)
{
    relList = other.relList;
    joinCond = other.joinCond;
    return(*this);
}


inline RdbQuery* RdbJoin::NewQuery(const BitVector& adorn)
{
    return Database().NewQuery(*this, adorn);
}

