// *************************************************************************
//    PipelinedExecInfo.h
// *************************************************************************

#ifndef _PipelinedExecInfo_H_
#define _PipelinedExecInfo_H_

#include "RuleInfo.h"
#include "StackMark.h"
#include "BindEnv.h"
#include "Rule.h"

// *************************************************************************

class Cor_TupleIterator;
class Cor_QFPipelinedModuleData;
class Cor_Table;

// *************************************************************************

class Cor_PipelinedExecInfo {

  public:
       // The following variables maintain state within a rule
       // Basically all fields used in SemiNaive::evaluate() have to
       // be available to PipelinedExecInfo::Solve()
     int                 current;
     int                 backtrack_index;

     unsigned int        direction;    // direction of current rule evaluation
     unsigned int        cut_crossed;  // has a cut been crossed in this rule?

     int                 successBacktrack;    // backtrack point on success
     int                *firstFailureBacktrack;
     int                *nextFailureBacktrack;

     Cor_RuleInfo       *rInfo;

     Cor_TupleIterator **tuple_its;
     Cor_StackMark       stackmark0;

        // BindEnv for the rule currently under consideration
     Cor_BindEnv        *env;

        // set of stack marks for the literals on rule rhs
     Cor_StackMark      *stack_marks;

        // will point to the indices in the QFPipelinedModuleData
     int                *indices;

        // set of tuples from literals on rhs of rule
        // and this tells us which rule we were at when we returned
     Cor_Tuple         **tuples;

        // points to the rule that is currently being examined
     Cor_Clause         *curRule;

        // points to the Table in QFPipelinedModuleData
     Cor_Table          *F;

     int                 numVars;
     int                 numLits;

     Cor_PipelinedExecInfo(Cor_QFPipelinedModuleData *md, int pred_offset);
    ~Cor_PipelinedExecInfo();

     int init();

     int Solve();
     int NextRule(Cor_QFPipelinedModuleData *md);
};

// *************************************************************************

#endif _PipelinedExecInfo_H_
