// *************************************************************************
//    BuiltinSymbols.h
// *************************************************************************

#ifndef _BuiltinSymbols_H_
#define _BuiltinSymbols_H_

// *************************************************************************

#ifndef Keyword
#define Keyword(x,s)     extern Cor_CArg *x;

#include "CArg.h" 
#include "Debug.h"


    // This has some extra space
#define    NUMBER_OF_BUILTINS    64

extern Cor_CArg  *Cor_builtin_ops[NUMBER_OF_BUILTINS];
extern int        Cor_Builtin_Arith_Start;
extern int        Cor_Builtin_Convertible_Start;

#endif    // Keyword

// *************************************************************************

Keyword(Cor_ConsSymbol,     "cons")
Keyword(Cor_ListSymbol,     "_LIST_")
Keyword(Cor_NestedSymbol,   "__NESTED__")
Keyword(Cor_NilSymbol,      "nil")
Keyword(Cor_TrueSymbol,     "true")
Keyword(Cor_ErrorSymbol,    "error")
Keyword(Cor_ModuleSymbol,   "module")
Keyword(Cor_ExportSymbol,   "export")
Keyword(Cor_QuerySymbol,    "query")
Keyword(Cor_DontCareSymbol, "_")
Keyword(Cor_CutSymbol,      "cut_")

// Arithmetic operations
Keyword(Cor_AddOpSymbol,    "add_")
Keyword(Cor_SubOpSymbol,    "sub_")
Keyword(Cor_MulOpSymbol,    "mul_")
Keyword(Cor_DivOpSymbol,    "div_")
Keyword(Cor_IDivOpSymbol,   "idiv_")
Keyword(Cor_EquOpSymbol,    "equ_")
Keyword(Cor_NeqOpSymbol,    "neq_")
Keyword(Cor_LssOpSymbol,    "lss_")
Keyword(Cor_GrtOpSymbol,    "grt_")
Keyword(Cor_LeqOpSymbol,    "leq_")
Keyword(Cor_GeqOpSymbol,    "geq_")

// Head aggregate operators
Keyword(Cor_SumOpSymbol,    "sum")
Keyword(Cor_ProdOpSymbol,   "prod")
Keyword(Cor_CountOpSymbol,  "count")
Keyword(Cor_MinOpSymbol,    "min")
Keyword(Cor_MaxOpSymbol,    "max")
Keyword(Cor_AvgOpSymbol,    "avg")
Keyword(Cor_StdDevOpSymbol, "stddev")
Keyword(Cor_ADstOpSymbol,   "avg_distinct")
Keyword(Cor_SDstOpSymbol,   "sum_distinct")
Keyword(Cor_PDstOpSymbol,   "prod_distinct")
Keyword(Cor_CDstOpSymbol,   "count_distinct")
Keyword(Cor_DstOpSymbol,    "distinct")

Keyword(Cor_AbsOpSymbol,    "abs")
Keyword(Cor_CeilOpSymbol,   "ceiling")
Keyword(Cor_FloorOpSymbol,  "floor")
Keyword(Cor_AnyOpSymbol,    "any")

// bitwise operator builtins
Keyword(Cor_LShiftOpSymbol, "lshift_")  //  <<
Keyword(Cor_RShiftOpSymbol, "rshift_")  //  >>
Keyword(Cor_BitorOpSymbol,  "bitor_")   //  bitor
Keyword(Cor_BitandOpSymbol, "bitand_")  //  bitand
Keyword(Cor_BitnotOpSymbol, "bitnot_")  //  bitnot
Keyword(Cor_BitxorOpSymbol, "bitxor_")  //  bitxor
Keyword(Cor_CompOpSymbol,   "comp_")    //  ~
Keyword(Cor_ModOpSymbol,    "mod_")     //  %

// set manipulation builtins
Keyword(Cor_AddElemSymbol,  "add_elem")
Keyword(Cor_AddElemDSymbol, "add_elem_d")
Keyword(Cor_CreateSetSymbol, "create_set")
//Keyword(MsetOpSymbol, "makeset")
Keyword(Cor_MemberSymbol,   "member")
Keyword(Cor_MemTupleSymbol, "memtuple")
Keyword(Cor_SubsetSymbol,   "subset")
Keyword(Cor_UnionSumSymbol, "unionsum")
Keyword(Cor_UnionMaxSymbol, "unionmax")
Keyword(Cor_UnionSumDSymbol, "unionsum_d")
Keyword(Cor_UnionMaxDSymbol, "unionmax_d")
Keyword(Cor_InterSymbol,    "inter")
Keyword(Cor_DifferenceSymbol, "difference")
Keyword(Cor_MakeSetSymbol,  "make_set")
Keyword(Cor_InterDSymbol,   "inter_d")
Keyword(Cor_DifferenceDSymbol, "difference_d")
Keyword(Cor_MakeSetDSymbol, "make_set_d")

Keyword(Cor_FunctorSymbol, "functor")
Keyword(Cor_ArgSymbol,     "arg")
Keyword(Cor_ArgsSymbol,    "args")
Keyword(Cor_UnivSymbol,    "univ")
Keyword(Cor_CallSymbol,    "call")


Keyword(Cor_PowSymbol,     "pow")

// string manipulation builtins
Keyword(Cor_LengthSymbol,    "length")
Keyword(Cor_ExtractSymbol,   "extract")
Keyword(Cor_SubstringSymbol, "substr")


// User annotations
Keyword(Cor_SupplementaryMagicSymbol, "sup_magic") 
Keyword(Cor_OrdinaryMagicSymbol, "magic") 
Keyword(Cor_NoMagicSymbol, "no_form_of_magic") 
Keyword(Cor_UseFactoringSymbol, "factoring")
Keyword(Cor_UseFactorMagicSymbol, "factor_magic")
Keyword(Cor_UsePipeliningSymbol, "pipelining")
Keyword(Cor_UseOrdSearchSymbol, "ordered_search")
Keyword(Cor_NoRewritingSymbol, "no_rewriting")
Keyword(Cor_NoPreProcessingSymbol, "no_preprocessing")
Keyword(Cor_NaiveBacktrackSymbol, "naive_backtracking")

Keyword(Cor_NestedSccEvalSymbol, "nested_scc_eval")

Keyword(Cor_SingleSccSymbol, "single_scc")
Keyword(Cor_SingleAnswerSymbol, "single_answer")
Keyword(Cor_ConvertFunctionsSymbol, "convert_functions")

Keyword(Cor_MultisetSymbol, "multiset") 
Keyword(Cor_CheckSubsumSymbol, "check_subsumption") 
Keyword(Cor_AggSelectionSymbol, "aggregate_selection")
Keyword(Cor_AggSel_PerIter_Symbol, "aggsel_per_iteration")
Keyword(Cor_AggSel_MultAnswers_Symbol, "aggsel_multiple_answers")
Keyword(Cor_ASyncRelSymbol, "async_rel")
Keyword(Cor_ChoiceSymbol, "choice")
Keyword(Cor_DiskResidentSymbol, "disk")

Keyword(Cor_IndexDeltaSymbol,"index_deltas") 
Keyword(Cor_ReturnUnifySymbol,"return_unify") 
Keyword(Cor_LazyEvalSymbol, "lazy_eval")
Keyword(Cor_MonotonicSymbol, "monotonic")
Keyword(Cor_MakeIndexSymbol, "make_index")
Keyword(Cor_AllowedAdornSymbol, "allowed_adornments")
Keyword(Cor_AllowedIndexSymbol, "allowed_index_args")
Keyword(Cor_SipReorderSymbol, "sip_reorder")
Keyword(Cor_EagerIndexingSymbol, "eager_indexing")

// Print builtins
Keyword(Cor_PrintEmptySymbol, "print_empty")
Keyword(Cor_PrintBindingSymbol, "print_bindings")
Keyword(Cor_PrintTupleSymbol, "print_tuple")
Keyword(Cor_PrintLiteralSymbol, "print_literal")
Keyword(Cor_DisplaySymbol,"print")
Keyword(Cor_PrintfSymbol,"printf")
Keyword(Cor_ScanfSymbol, "scanf")
Keyword(Cor_PrintModSymbol, "print_module")

// Builtin relations
Keyword(Cor_AliasSymbol, "alias_rel")
Keyword(Cor_AssignSymbol,"assign")
Keyword(Cor_ClearSymbol, "clear")
Keyword(Cor_ConsultSymbol,"consult") 
Keyword(Cor_CoralRootSymbol,"coralroot")
Keyword(Cor_CpuTimeSymbol, "cputime")
Keyword(Cor_DeleteFactSymbol, "delete")
Keyword(Cor_DisplayTimerSymbol, "display_timer")
Keyword(Cor_ExplainOffSymbol, "explain_off")
Keyword(Cor_ExplainOnSymbol, "explain_on")
Keyword(Cor_FailSymbol,"fail") 
Keyword(Cor_HelpSymbol,"help")
Keyword(Cor_CoralHelpSymbol,"coral_help")
Keyword(Cor_HistorySymbol, "history")
Keyword(Cor_InsertFactSymbol, "insert")
Keyword(Cor_PipeInSymbol,"pipein") 
Keyword(Cor_PipeOutSymbol,"pipeout") 
Keyword(Cor_ProfileOffSymbol, "profile_off")
Keyword(Cor_ProfileOnSymbol, "profile_on")
Keyword(Cor_QuitSymbol,"quit") 
Keyword(Cor_StartTimerSymbol, "reset_timer")
Keyword(Cor_SetSymbol,   "set")
Keyword(Cor_BreakSymbol, "set_break")
Keyword(Cor_ClearBreakSymbol, "clear_break")
Keyword(Cor_ShellSymbol, "shell")
Keyword(Cor_TraceSymbol, "trace_on")
Keyword(Cor_UntraceSymbol, "trace_off")
Keyword(Cor_WriteTableSymbol, "write_table")
Keyword(Cor_ShowMemSymbol, "show_mem")

/*    Fixed arrays are _out_
Keyword(Cor_ArrayConstructorSymbol, "array")
Keyword(Cor_ArrayDestructorSymbol, "destruct")
Keyword(Cor_ArrayLookupSymbol, "lookup")
Keyword(Cor_ArrayBindSymbol, "bind")
*/

// Builtin relations for suspensions and client/server operation
Keyword(Cor_AnswerSymbol, "answer")
Keyword(Cor_KillSymbol, "kill")
Keyword(Cor_ListSusSymbol, "list_sus")
Keyword(Cor_LoginSymbol, "login")
Keyword(Cor_LogoutSymbol, "logout")
Keyword(Cor_ResumeSymbol, "resume")
Keyword(Cor_SocketRelSymbol, "socket_rel")
Keyword(Cor_AsynSocketRelSymbol, "asyn_socket_rel")
Keyword(Cor_UrlRelSymbol, "url_rel")
Keyword(Cor_SyncSymbol, "sync")
Keyword(Cor_UserSymbol, "user")
Keyword(Cor_WhoSymbol, "who")
Keyword(Cor_WhoamiSymbol, "whoami")
Keyword(Cor_YieldSymbol, "yield")
Keyword(Cor_SetQidSymbol,  "setqid")
Keyword(Cor_CollectionSymbol, "collection")
Keyword(Cor_ProducerSymbol, "producer")
Keyword(Cor_ConsumerSymbol, "consumer")

// Counter Stuff
Keyword(Cor_CounterSymbol, "c_counter")
Keyword(Cor_ResetCounterSymbol, "reset_c_counter")

// Builtin relations to deal with multiple workspaces( nee\ databases)
Keyword(Cor_CreateDBSymbol, "ws_create")
Keyword(Cor_DestroyDBSymbol, "ws_destroy")
Keyword(Cor_CurrentDBSymbol, "ws_current")
Keyword(Cor_SaveDBSymbol, "ws_save")
Keyword(Cor_RenameDBSymbol, "ws_rename")
Keyword(Cor_ClearDBSymbol, "ws_clear")
Keyword(Cor_CopyRelToDBSymbol, "rel_copy")
Keyword(Cor_AddRelToDBSymbol, "rel_add")
Keyword(Cor_ClearRelSymbol, "rel_clear")
Keyword(Cor_CloseRelSymbol, "rel_close")
Keyword(Cor_RenameRelSymbol, "rel_rename")
Keyword(Cor_ListRelsInDBSymbol, "list_rels")
Keyword(Cor_ListDBSymbol, "list_ws")
Keyword(Cor_OpenRelInDBSymbol, "rel_open")

// Builtin relations to handle the default execution environment
Keyword(Cor_DisplayDefaultsSymbol, "display_defaults")
Keyword(Cor_ResetDefaultsSymbol, "reset_defaults")

// Builtin relations to check the type of an arg
Keyword(Cor_IsConstantSymbol, "is_constant")
Keyword(Cor_IsVarSymbol, "is_var")
Keyword(Cor_IsListSymbol, "is_list")
Keyword(Cor_IsFunctorSymbol, "is_functor")
Keyword(Cor_IsStringSymbol, "is_string")
Keyword(Cor_IsNumSymbol, "is_num")
Keyword(Cor_IsIntSymbol, "is_int")
Keyword(Cor_IsLongSymbol, "is_long")
Keyword(Cor_IsShortSymbol, "is_short")
Keyword(Cor_IsFloatSymbol, "is_float")
Keyword(Cor_IsDoubleSymbol, "is_double")


// used with Exodus: ( WITH_PERSISTENCE )

Keyword(Cor_SchemaSymbol, "schema")
Keyword(Cor_DelSchemaSymbol, "del_schema")
Keyword(Cor_BulkLoadSymbol, "bulkload")

Keyword(Cor_BeginTransSymbol, "t_begin")
Keyword(Cor_CommitTransSymbol, "t_commit")
Keyword(Cor_AbortTransSymbol, "t_abort")

Keyword(Cor_ExtJoinSymbol, "ext_join")

Keyword(Cor_StartBulkLoadSymbol, "start_bulk_load")
Keyword(Cor_EndBulkLoadSymbol, "end_bulk_load")


  // Used by SortedRelation
Keyword(Cor_SortSymbol, "sort")
Keyword(Cor_IncrSymbol, "incr")
Keyword(Cor_DecrSymbol, "decr")

// *************************************************************************

void Cor_init_builtin_symbols();
void Cor_free_builtin_symbols();

#undef  Keyword

// *************************************************************************

#endif _BuiltinSymbols_H_
